#ifndef RESOURCES_HH
#define RESOURCES_HH

#include "FbPager.hh"

#include "FbTk/Resource.hh"
#include <string>
#include <cstdio>
#include <cstring>

namespace FbTk {

template<>
void Resource<bool>::
setFromString(char const *strval) {
    if (strcasecmp(strval, "true") == 0 ||
        strcasecmp(strval, "yes") == 0)
        *this = true;
    else
        *this = false;
}

template<>
std::string Resource<bool>::
getString() {
    return std::string(**this == true ? "true" : "false");
}

template <>
void Resource<std::string>::setFromString(const char *str) {
    *(*this) = (str ?  str : "");
}

template <>
std::string Resource<std::string>::getString() {
    return *(*this);
}

template <>
void Resource<int>::setFromString(const char *str) {
    if (str == 0)
        return;
    sscanf(str, "%d", &(*(*this)));
}

template <>
std::string Resource<int>::getString() {
    char buff[16];
    sprintf(buff, "%d", (*(*this)));
    return std::string(buff);
}

template <>
void Resource<FbPager::FbPager::Alignment>::setFromString(const char *str) {
    if (strcmp("TopToBottom", str) == 0)
        *(*this) = FbPager::FbPager::TOP_TO_BOTTOM;
    else
        *(*this) = FbPager::FbPager::LEFT_TO_RIGHT;
}

template <>
std::string Resource<FbPager::FbPager::Alignment>::getString() {
    switch (*(*this)) {
    case FbPager::FbPager::LEFT_TO_RIGHT:
        return "LeftToRight";
    case FbPager::FbPager::TOP_TO_BOTTOM:
        return "TopToBottom";
    }
}

} // end namespace FbTk

#endif // RESOURCES
